#include <jsonincpp/string_representation.h>
#include <new_york_transit_line/templater.h>
#include <new_york_transit_line/core.h>
#include <engine_engine_number_9/os_utils.h>

int main(int argc, char** argv) {
    if (argc < 3) {
        fprintf(stderr, "Usage: test assets_dir config_file");
        exit(1);
    }

    std::string dir_path = argv[1];
    nytl::Templater templater(nytl::TemplaterSettings{nytl::TemplaterDetourRules{dir_path}});
    templater.update();

    std::string config_file = argv[2];
    std::string config_text;
    een9::readFile(config_file, config_text);
    const json::JSON config = json::parse_str_flawless(config_text);

    std::string answer2 = templater.render("login", {&config["presentation"].g()});
    printf("%s\n<a><f><t><e><r><><l><f>\n", answer2.c_str());

    return 0;
}
